stages:
    - build
    - sca_and_pipeline_scan
    - sandbox_scan
    - policy_scan
    - Dynamic_Analysis

build:
    image: python:3.11.0b1-buster
    stage: build
    only:
        - branches
        - tags
        - merge_requests
    script:
        - python -m pip install --no-cache-dir pip==22.0.4
    after_script:
        - echo "(Build) done!"

sca_security_scanning:
    image: python:3.11.0b1-buster
    stage: sca_and_pipeline_scan
    script:
         - curl -sSL https://download.sourceclear.com/ci.sh | bash -s scan --update-advisor || true
    dependencies:
        - build

pipeline_scan:
  image: veracode/pipeline-scan:latest
  stage: sca_and_pipeline_scan
  script:
    - zip -r pygoat.zip . -x "*.sample" "*.png" "*.txt" "*svg" "*.jpg"
    - >
    - java -jar /opt/veracode/pipeline-scan.jar 
        -vid "${VID}" 
        -vkey "${VKEY}"
        --file pygoat.zip
        --policy_name "Veracode Recommended SCA Low"
        -- summary_display true
      || true
  dependencies:
      - build

sast_sandbox_scan:
    image: veracode/api-wrapper-java
    stage: sandbox_scan
    script:
        - zip -r pygoat.zip . -x "*.sample" "*.png" "*.txt" "*svg" "*.jpg"
        - >
        - java -jar /opt/veracode/api-wrapper.jar
          -action UploadAndScan 
          -appname Pygoat-Showroom
          -createprofile true
          -vid "${VID}"
          -vkey "${VKEY}"
          -sandboxname $CI_COMMIT_REF_NAME 
          -createsandbox true
          -sandboxname SANDBOX_1
          -filepath pygoat.zip
          -version "pipeline $CI_PIPELINE_ID job $CI_JOB_ID"
    dependencies:
        - build

sast_policy_scan:
    image: veracode/api-wrapper-java
    stage: policy_scan
    script:
        - zip -r pygoat.zip . -x "*.sample" "*.png" "*.txt" "*svg" "*.jpg"
        - >
        - java -jar /opt/veracode/api-wrapper.jar
          -action UploadAndScan 
          -appname Pygoat-Showroom
          -createprofile false
          -vid "${VID}"
          -vkey "${VKEY}"
          -filepath pygoat.zip
          -version "pipeline $CI_PIPELINE_ID job $CI_JOB_ID"
    dependencies:
        - build

Dynamic Analysis:
    image: veracode/api-signing
    stage: Dynamic_Analysis
    only:
        - development
        - release
        - master
    before_script:
        - export VERACODE_API_KEY_ID=${VID}
          export VERACODE_API_KEY_SECRET=${VKEY}
    script:
        - http --auth-type veracode_hmac PUT https://api.veracode.com/was/configservice/v1/analyses/a4eef9c7d46ab2b827217a31c75385a6?method=PATCH < da_scan_update.json
